<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
  <modelVersion>4.0.0</modelVersion>
  <parent>
    <artifactId>GroIMP</artifactId>
    <groupId>de.grogra</groupId>
    <version>2.1.6</version>
  </parent>

  <artifactId>graph</artifactId>
  <packaging>jar</packaging>

  <name>Graph</name>
  
  <repositories>
	  <repository>
	    <id>gitlab-maven</id>
	    <url>https://gitlab.com/api/v4/groups/55048746/-/packages/maven</url>
	  </repository>
	</repositories>

  <dependencies>
    <dependency>
      <groupId>junit</groupId>
      <artifactId>junit</artifactId>
      <version>4.11</version>
      <scope>test</scope>
    </dependency>
    <dependency>
      <groupId>de.grogra</groupId>
      <artifactId>xl.core</artifactId>
      <version>${groimp.core.version}</version>
    </dependency>
    <dependency>
      <groupId>de.grogra</groupId>
      <artifactId>utilities</artifactId>
      <version>${groimp.core.version}</version>
    </dependency>
    
	<dependency>
		<groupId>com.saxonica</groupId>
		<artifactId>xmldoclet</artifactId>
		<version>0.4.0</version>
		<scope>test</scope>
		  <exclusions>
		    <exclusion>
		      <groupId>net.sf.saxon</groupId>
		      <artifactId>Saxon-HE</artifactId>
		    </exclusion>
	  </exclusions>
	</dependency>

    
  </dependencies>

  <build>
	  <finalName>${project.name}</finalName>
	  
	  <plugins>
	  <!--
		  <plugin>
	      <groupId>org.apache.maven.plugins</groupId>
	      <artifactId>maven-javadoc-plugin</artifactId>
				<version>3.8.0</version>
				<configuration>
	    		<doclint>none</doclint>
	    		<destDir>${project.build.directory}/classes/javadoc</destDir>
			    <overview></overview>
			    <doctitle>Functions Browser</doctitle> 
	        <sourceFileIncludes>
						<include>Graph.java</include>
						<include>GraphManager.java</include>
				</sourceFileIncludes>
				<sourcepath>${basedir}/src/main/java/de/grogra/graph:${basedir}/src/main/java/de/grogra/graph/impl</sourcepath>
				<includeDependencySources>true</includeDependencySources>
        <additionalDependencies>
            <additionalDependency>
              <groupId>${project.groupId}</groupId>
              <artifactId>${project.artifactId}</artifactId>
              <version>${project.version}</version>
            </additionalDependency>
          </additionalDependencies>
			  </configuration>
			  
			  <executions>
	      <execution>
					<id>build-xmldoc</id>
					<phase>prepare-package</phase>
					<goals>
						<goal>jar</goal>
					</goals>
					
				</execution>
		</executions>
	    </plugin>
	    -->
	    
	    <plugin>
					<artifactId>maven-resources-plugin</artifactId>
					<version>3.0.2</version>
					<executions>
						  <execution>
						      <id>copy-class-for-xmldoc</id>
						      <phase>generate-sources</phase>
						      <goals>
						          <goal>copy-resources</goal>
						      </goals>
						      <configuration>
						          <outputDirectory>${basedir}/target/source-xmldoc/de/grogra/graph</outputDirectory>
						          <resources>
						              <resource>
						                  <directory>src/main/java/de/grogra/graph</directory>
						                  <includes>
						                      <include>Graph.java</include>
						                      <include>impl/GraphManager.java</include>
						                      <include>impl/Node.java</include>
						                  </includes>
						              </resource>
						          </resources>
						      </configuration>
						  </execution>
						  <execution>
						      <id>move-xmldoc</id>
						      <phase>prepare-package</phase>
						      <goals>
						          <goal>copy-resources</goal>
						      </goals>
						      <configuration>
						          <outputDirectory>${basedir}/target/classes/xmldoc</outputDirectory>
						          <resources>
						              <resource>
						                  <directory>${basedir}/target/site/apidocs/xmldoc</directory>
						                  <includes>
						                      <include>doclet.xml</include>
						                  </includes>
						              </resource>
						          </resources>
						      </configuration>
						  </execution>
					</executions>
			</plugin>


	    <plugin>
				<groupId>org.apache.maven.plugins</groupId>
				<artifactId>maven-javadoc-plugin</artifactId>
        <configuration>
          <doclet>com.saxonica.xmldoclet.XmlDoclet</doclet>
          <useStandardDocletOptions>false</useStandardDocletOptions>
          <docletArtifacts>
	          <docletArtifact>
								<groupId>com.saxonica</groupId>
								<artifactId>xmldoclet</artifactId>
								<version>0.4.0</version>
	          </docletArtifact>
	          <docletArtifact>
								<groupId>com.github.javaparser</groupId>
								<artifactId>javaparser-core</artifactId>
								<version>3.25.4</version>
	          </docletArtifact>
          </docletArtifacts>
          <doclint>none</doclint>
					<destDir>xmldoc</destDir>
					<overview></overview>
					<sourcepath>${basedir}/target/source-xmldoc</sourcepath>

	        <additionalDependencies>
				  <additionalDependency>
				    <groupId>${project.groupId}</groupId>
				    <artifactId>${project.artifactId}</artifactId>
				    <version>${project.version}</version>
				  </additionalDependency>
				</additionalDependencies>
      </configuration>
				<executions>
				    <execution>
				        <id>generate-xml-doclet</id>
				        <phase>process-classes</phase>
				        <goals>
				            <goal>javadoc</goal>
				        </goals>
				    </execution>
				</executions>
		</plugin>
	    
      </plugins>
  </build>
</project>
